#pragma once

#include <Arduino.h>
#include <SPI.h>
#include <LiquidCrystal.h>
#include <vector>

class AD5543 {
  private:
    byte _CSpin, _highCurrentpin;
    float _fullScaleCurrent;
    boolean _enabled, _highcurrentmode;
    SPISettings _AD5543SPISettings;
    float _scaler;
    LiquidCrystal& _lcd;
    unsigned int _column;
    void SendCommand(std::vector<byte> &data);
    float _setpointCurrent, _current;
  public:
    AD5543(byte CSpin, byte highCurrentpin, float fullScaleCurrent, LiquidCrystal& lcd, unsigned int column);
    void begin(float current);
    void SetCurrent(float current);
    void SetScaler(float scaler);
    void SetHighCurrent(void);
    void SetLowCurrent(void);
    void UpdateCurrent(void);
    boolean GetCurrentMode(void);
    void Enable(void);
    void Disable(void);
    float GetCurrent(void);
};
