#pragma once

#include <Arduino.h>
#include <SPI.h>
#include <LiquidCrystal.h>
#include <vector>

class AD9838 {
  private:
    float _MCLK;
    byte _CSpin, _RSTpin, _PHASEpin, _FRQpin, _SIGNpin;
    SPISettings _AD9838SPISettings;
    LiquidCrystal& _lcd;
    unsigned int _column;
    void SendCommand(std::vector<byte> &data);
    float _Freq = 0;
  public:
    AD9838(float MCLK, byte CSpin, byte RSTpin, byte PHASEpin, byte FRQpin, byte SIGNpin, LiquidCrystal& lcd, unsigned int column);
    void begin(float value);
    void SetFreq(float value);
    void Synchronize(void);
    float GetFreq(void);
    float GetMCLK(void);
    void SetMode(boolean value); // Mode 1 is triangle wave, Mode 0 is sine wave.
};
