#include "LED.h"

LED::LED(byte redPin, byte greenPin, byte bluePin):
      _redPin(redPin),
      _greenPin(greenPin),
      _bluePin(bluePin) {};

void LED::begin(void) {
  // Configure Pins.
  pinMode(_redPin, OUTPUT);
  pinMode(_greenPin, OUTPUT);
  pinMode(_bluePin, OUTPUT);

  analogWrite(_redPin, 0);
  analogWrite(_greenPin, 0);
  analogWrite(_bluePin, 0);
}

void LED::setColor(float H, float I) {
  int r, g, b;
  float cos_h, cos_1047_h;
  H = fmod(H, 360);
  H = 3.14156*H/(float)180;
  if (H < 2.09439) {
    cos_h = cos(H);
    cos_1047_h = cos(1.047196667-H);
    r = 255*I/3*(1+cos_h/cos_1047_h);
    g = 255*I/3*(1+(1-cos_h/cos_1047_h));
    b = 0;
  } else if(H < 4.188787) {
    H = H - 2.09439;
    cos_h = cos(H);
    cos_1047_h = cos(1.047196667-H);
    g = 255*I/3*(1+cos_h/cos_1047_h);
    b = 255*I/3*(1+(1-cos_h/cos_1047_h));
    r = 0;
  } else {
    H = H - 4.188787;
    cos_h = cos(H);
    cos_1047_h = cos(1.047196667-H);
    b = 255*I/3*(1+cos_h/cos_1047_h);
    r = 255*I/3*(1+(1-cos_h/cos_1047_h));
    g = 0;
  }
  
  analogWrite(_redPin, r);
  analogWrite(_greenPin, g);
  analogWrite(_bluePin, b);
}
